import { world, system, EquipmentSlot} from "@minecraft/server";
import { launchPlayer } from "./../../util/movements.js";
import { weaponDamageIndicator, generateUniqueId, stunDamageIndicator } from "./../../util/utils.js";
import { attackPlayerMeikyu, executer, plunge } from "./../../util/attackMethods.js";
const animations =[ 
    [
        {
            animation: "minced.grand_cross.attack_sprint",
            knockback: [5,0.25],
            Player_Knockback: [1,0],
            type: "slash",
            attack_speed: 8,
            hit_number: 1,
            stun_type: "long",
            range: 3,
            distance: 1,
            targetNum: 1,
            damage_multiplier: 1,
            stun_damage_multiplier: 1,
            next_attack_time: 5,
            Unbreakable: false
        },
        {
            animation: "minced.grand_cross.attack0",
            knockback: [1,0],
            Player_Knockback: [2,0],
            type: "blunt",
            attack_speed: 14,
            hit_number: 1,
            stun_type: "long",
            range: 3,
            distance: 1,
            targetNum: 10,
            damage_multiplier: 1.5,
            stun_damage_multiplier: 1.5,
            next_attack_time: 10,
            Unbreakable: false
        },
        {
            animation: "minced.grand_cross.attack1",
            knockback: [1,0.15],
            Player_Knockback: [2,0],
            type: "blunt",
            attack_speed: 14,
            hit_number: 1,
            stun_type: "long",
            range: 3,
            distance: 1,
            targetNum: 10,
            damage_multiplier: 1.5,
            stun_damage_multiplier: 1.25,
            next_attack_time: 10,
            Unbreakable: false
        },
        {
            animation: "minced.grand_cross.attack2",
            knockback: [1,0.15],
            Player_Knockback:[2,0],
            type: "blunt",
            attack_speed: 14,
            hit_number: 1,
            stun_type: "knockdown",
            range: 3,
            distance: 1,
            targetNum: 10,
            damage_multiplier: 1.5,
            stun_damage_multiplier: 2,
            next_attack_time: 10,
            Unbreakable: false
        }
    ]
]

const weapon = {
    name: 'grand_cross',
    display_name: "Grand Cross",
    dual_wield: ["dagger","sword","rapier","pistol","spear"],
    type: "special",
    can_block: true,
    block_damage: 45,
    block_power: 60,
    block_time: 8,
    clash_power: 90,
    front_dodge: [3, 0.2],
    back_dodge:[-3, 0.2],
    left_dodge:'none',
    right_dodge:"none",
    stylePrefixes: ["minced.grand_cross"],
    weaponSize: "large",
    cd: 20,
    available_moves: [],
    execute(player, weapon, effect, mode, burn) {
        const cd = this.cd
        const blckdmg = this.block_damage
        let lavander = weaponDamageIndicator(weapon)
        let stundamage = stunDamageIndicator(weapon.getTags())
        let critChance = Math.floor(Math.random()*15)
        let critDamage = 0
        critChance == 2 ? critDamage = Math.floor(Math.random() * lavander) : critDamage = 0
        lavander = JSON.parse(lavander) + critDamage
        let animChecker
        let atkspd
        for(let i = animations[0].length - 1; i > 0; i--) {
            if(player.getDynamicProperty("combo") % i == 0) {
                animChecker = i
                break;
            }
        }
        let attackEffect = []
        attackEffect.push(effect)
        switch(mode) {
            case "sprint":{
                let propCheck = animations[0][0]
                let knockback = propCheck.knockback
                player.playAnimation(`animation.${propCheck.animation}`)
                atkspd = propCheck.attack_speed
                let Pknockback = propCheck.Player_Knockback 
                let effects = propCheck.type
                let stun = propCheck.stun_type
                let ranger = propCheck.range
                let distil = propCheck.distance
                let tgtnm = propCheck.targetNum
                let NAT = propCheck.next_attack_time
                let stunD = stundamage * propCheck.stun_damage_multiplier
                let breakable = propCheck.Unbreakable
                let hitCount = propCheck.hit_number
                system.runTimeout(()=>{
                    launchPlayer(player, Pknockback[0], Pknockback[1])
                },atkspd)
                if(animChecker == 3) {
                    player.addEffect("slow_falling", 16, { amplifier: 3, showParticles: false })
                }
                attackPlayerMeikyu(player, ranger, (lavander * propCheck.damage_multiplier), blckdmg, cd, atkspd, distil, tgtnm, "line_target", attackEffect, knockback, stun, "", effects, (animations[0].length - 1), stunD, NAT, breakable, "no cooldown",weapon, hitCount, true)
            } break;
            case "jump": {
                if(world.scoreboard.getObjective("exhaust").getScore(player) < 20) {
                    player.setDynamicProperty("attacking",0)
                    world.scoreboard.getObjective("combatCooldown").setScore(player, 10)
                    world.scoreboard.getObjective("combatCheck").setScore(player, 0)
                    player.runCommandAsync("tag @s remove attack")
                    return;
                }
                let propCheck = {
                    animation: "minced.grand_cross.attack_jump",
                    knockback: [1,0.75],
                    Player_Knockback: [0,0],
                    type: "pierce",
                    attack_speed: 8,
                    hit_number: 1,
                    stun_type: "knockdown",
                    range: 3,
                    distance: 1,
                    targetNum: 1,
                    damage_multiplier: 1.5,
                    stun_damage_multiplier: 2,
                    next_attack_time: 16,
                    Unbreakable: false
                }
                let knockback = propCheck.knockback
                player.playAnimation(`animation.${propCheck.animation}`)
                atkspd = propCheck.attack_speed
                let Pknockback = propCheck.Player_Knockback 
                let effects = propCheck.type
                let stun = propCheck.stun_type
                let ranger = propCheck.range
                let distil = propCheck.distance
                let tgtnm = propCheck.targetNum
                let NAT = propCheck.next_attack_time
                let stunD = stundamage * propCheck.stun_damage_multiplier
                let breakable = propCheck.Unbreakable
                let hitCount = propCheck.hit_number
                system.runTimeout(()=>{
                    launchPlayer(player, Pknockback[0], Pknockback[1])
                },atkspd-5)
                player.addEffect("slow_falling", 16, { amplifier: 3, showParticles: false })
                attackPlayerMeikyu(player, ranger, (lavander * propCheck.damage_multiplier), blckdmg, cd, atkspd, distil, tgtnm, "line_target", attackEffect, knockback, stun, "", effects, (animations[0].length - 1), stunD, NAT, breakable, "no cooldown",weapon, hitCount, true)
            } break;
            case "on_air": {
                atkspd = 8
                player.playAnimation(`animation.minced.grand_cross.attack_shizzzzaaaaa`, {
                    stopExpression: "query.is_on_ground",
                    blendOutTime: 0.5
                })
                player.addEffect("slow_falling", 100, { amplifier: 3, showParticles: false })
                player.applyKnockback(player.getViewDirection().x, player.getViewDirection().z, 0, 1.5)
                plunge(player, 3, ((lavander + (lavander * 0.7))*2), cd, atkspd, 0, 0, -2, "grand_cross")
            } break;
            case "execute": {
                executer(player, burn, (lavander * 200), this.name, 44)
            } break;
            default: {
                let propCheck = animations[0][animChecker]
                let knockback = propCheck.knockback
                player.playAnimation(`animation.${propCheck.animation}`)
                atkspd = propCheck.attack_speed
                let Pknockback = propCheck.Player_Knockback 
                let effects = propCheck.type
                let stun = propCheck.stun_type
                let ranger = propCheck.range
                let distil = propCheck.distance
                let tgtnm = propCheck.targetNum
                let NAT = propCheck.next_attack_time
                let stunD = stundamage * propCheck.stun_damage_multiplier
                let breakable = propCheck.Unbreakable
                let hitCount = propCheck.hit_number
                system.runTimeout(()=>{
                    launchPlayer(player, Pknockback[0], Pknockback[1])
                },atkspd)
                if(animChecker == 3) {
                    player.addEffect("slow_falling", 16, { amplifier: 3, showParticles: false })
                }
                attackPlayerMeikyu(player, ranger, (lavander * propCheck.damage_multiplier), blckdmg, cd, atkspd, distil, tgtnm, "line_target", attackEffect, knockback, stun, "", effects, (animations[0].length - 1), stunD, NAT, breakable, "no cooldown",weapon, hitCount, true)
            }
            break;
        }
    },
    setCore(player, item) {
        let Abilities = [
            {
              Id: "S2",
            },
            {
              Id: "D2",
            },
            {
              Id: "R2",
            },
            {
              Id: "B3",
            },
            {
              Id: "O0",
            }
          ]
          item.setDynamicProperty("abilities", JSON.stringify(Abilities))
          item.setDynamicProperty("fightStyle", 1)
        player.getComponent('equippable')?.setEquipment(EquipmentSlot.Mainhand, item)
    },
    getCurrentAtkspd(player, combo) {
        let animChecker
        for(let i = (animations[0].length - 1); i > 0; i--) {
            if(player.getDynamicProperty("combo") % i == 0) {
                animChecker = i
                break;
            }
        }
        return animations[0][animChecker].attack_speed
    } 
}

export default weapon


